Program Eliza;     {$U+,R+,V-}

{       Psychologischer Berater ELIZA        }
{       =============================        }
{                                            }
{       (C)  copyright by                    }
{                                            }
{       Dipl.-Inform. Gustav Wostrack        }
{       Im Schenkelsberg 28                  }
{       5400 Koblenz                         }

{       aus MICRO EXTRA, Heft 3/1986         }
{       Korrekturen und Aenderungen:         }
{       Juergen Gaertner    24.12.88         }


Const
  Anzkeyw  = 45;  {Anzahl der Schluesselworte}
  Anzant   =138;  {Anzahl der Antworten      }
  Anzpers  = 14;  {Anzahl der Pronomen       }

Var
  S,R,N    : Array[1..Anzkeyw] of Integer;
                  { S[x] Nummer der ersten moeglichen Antwort }
                  {      des Stichwortes x                    }
                  { R[x] Nummer der aktuellen Antwort         }
                  {      des Stichwortes x                    }
                  { N[x] Nummer der letzten Antwort           }
                  {      des Stichwortes x                    }
  Person   : Array[1..Anzpers] of String[7];
                  {      Liste der Pronomen                   }
  Answer   : Array[1..Anzant]  of String[80];
                  {      Liste der Antworten                  }
  Keyword  : Array[1..Anzkeyw] of String[15];
                  {      Liste der Schluesselworte            }
  Antwort,
  Satz,
  Eingabe,
  Einggros,
  Eingbalt : String[80];
  Antw_nr,
  T,T1,
  Position,
  U,V      : Integer;
  found    : Boolean;


Procedure Fill_s_r(x,Sx,Lx : Integer);
{ R beginnt jeweils mit dem Wort von S; wird nach jeder Ant-  }
{ wort erhoeht (so dass beim naechsten Auftreten des gleichen }
{ Stichwortes eine neue Antwort vorkommt) bis es N erreicht   }
{ und wieder auf S gesetzt wird.                              }
Begin
  S[x] := Sx;
  R[x] := Sx;
  N[x] := Sx+Lx-1;
End;

Begin
{ Initialisierung           }
{ Liste der Schluesselworte }
Keyword[ 1] := 'YES ';
Keyword[ 2] := 'I HAVE ';
Keyword[ 3] := 'I HAD ';
Keyword[ 4] := 'I WILL ';
Keyword[ 5] := 'I WOULD ';
Keyword[ 6] := 'I WAS ';
Keyword[ 7] := 'I LIKE ';
Keyword[ 8] := 'I DONT ';
Keyword[ 9] := 'I FEEL ';
Keyword[10] := 'I CANT ';
Keyword[11] := 'I AM ';
Keyword[12] := ' IM ';
Keyword[13] := 'I WANT ';
Keyword[14] := 'WHAT ';
Keyword[15] := 'HOW ';
Keyword[16] := 'WHO ';
Keyword[17] := 'WHERE ';
Keyword[18] := 'WHEN ';
Keyword[19] := 'WHY ';
Keyword[20] := 'HAVE YOU ';
Keyword[21] := 'WOULD YOU ';
Keyword[22] := 'CAN YOU ';
Keyword[23] := 'CAN I ';
Keyword[24] := 'YOU ARE ';
Keyword[25] := 'YOURE ';
Keyword[26] := 'WHY DONT YOU ';
Keyword[27] := 'WHY CANT I ';
Keyword[28] := 'ARE YOU ';
Keyword[29] := 'NAME';
Keyword[30] := 'CAUSE';
Keyword[31] := 'SORRY';
Keyword[32] := 'DREAM';
Keyword[33] := 'HELLO ';
Keyword[34] := 'THINK ';
Keyword[35] := 'MAY ';
Keyword[36] := ' NO ';
Keyword[37] := 'YOUR ';
Keyword[38] := 'ALWAYS ';
Keyword[39] := 'HI ';
Keyword[40] := 'YOU ';
Keyword[41] := 'FRIEND';
Keyword[42] := 'COMPUTER';
Keyword[43] := 'MONEY';
Keyword[44] := 'ELIZA';
Keyword[45] := 'NOKEYFOUND';

{ Liste der Pronomen }
Person[ 1] := ' are ';
Person[ 2] := ' am ';
Person[ 3] := 'were ';
Person[ 4] := 'was ';
Person[ 5] := ' you ';
Person[ 6] := ' me ';
Person[ 7] := 'your ';
Person[ 8] := 'my ';
Person[ 9] := 'Ive ';
Person[10] := ' youve ';
Person[11] := ' Im ';
Person[12] := ' youre ';
Person[13] := ' you ';
Person[14] := ' I ';

{ Liste der Antworten }
  {I have }
Answer[  1]:= 'Mr. Gardener already told me that you have*';
Answer[  2]:= 'It would be better you wouldn''t have*';
  {I had }
Answer[  3]:= 'It would be beautiful if I also had*';
Answer[  4]:= 'Tell me more about such nice things.';
  {I will ,I would}
Answer[  5]:= 'That I also would to do.';
Answer[  6]:= 'That would you really do?';
Answer[  7]:= 'It''s better you don''t*';
Answer[  8]:= 'Leave it alone!';
  {I was }
Answer[  9]:= 'Say was it beautiful when you was*';
Answer[ 10]:= 'Last week Mr. Gardener also was*';
Answer[ 11]:= 'Sometimes I also was*';
  {I like }
Answer[ 12]:= 'In what way?';
Answer[ 13]:= 'Do you really enjoy in*';
Answer[ 14]:= 'When do you want*';
Answer[ 15]:= 'Have you ever tried to satisfy yourself?';
  {Can you }
Answer[ 16]:= 'Don''t you believe that I can*';
Answer[ 17]:= 'Perhaps you would like to be able to*';
Answer[ 18]:= 'You want me to be able to*';
  {Can I }
Answer[ 19]:= 'Perhaps you don''t want to*';
Answer[ 20]:= 'Do you want to be able to*';
  {You are ,youre}
Answer[ 21]:= 'What makes you think that I am*';
Answer[ 22]:= 'Does it please you to believe I am*';
Answer[ 23]:= 'Perhaps you would like to be*';
Answer[ 24]:= 'Do you sometimes wish you were*';
  {I don't }
Answer[ 25]:= 'Don''t you really*';
Answer[ 26]:= 'Why don''t you*';
Answer[ 27]:= 'Do you wish to be able to*';
Answer[ 28]:= 'Does that trouble you?';
  {I feel }
Answer[ 29]:= 'Tell me more about such feelings.';
Answer[ 30]:= 'Do you often feel*';
Answer[ 31]:= 'Do you enjoy feeling*';
  {Why don't you }
Answer[ 32]:= 'Do you really believe I don''t*';
Answer[ 33]:= 'Perhaps in good time I will*';
Answer[ 34]:= 'Do you want me to*';
  {Why can't I }
Answer[ 35]:= 'Do you think you should be able to*';
Answer[ 36]:= 'Why can''t you*';
  {Are you }
Answer[ 37]:= 'Why are you interested in whether or not I am*';
Answer[ 38]:= 'Would you prefer if I were not*';
Answer[ 39]:= 'Perhaps in your fantasies I am*';
  {I can't }
Answer[ 40]:= 'How do you know you can''t*';
Answer[ 41]:= 'Have you tried?';
Answer[ 42]:= 'Perhaps you can now*';
  {I am }
Answer[ 43]:= 'Did you come to me because you are*';
Answer[ 44]:= 'How long have you been*';
Answer[ 45]:= 'Do you believe it is normal to be*';
Answer[ 46]:= 'Do you enjoy being*';
  {I want }
Answer[ 47]:= 'Sometimes I also want*';
Answer[ 48]:= 'Why do you want*';
Answer[ 49]:= 'Suppose you soon got*';
Answer[ 50]:= 'What if you never got*';
Answer[ 51]:= 'What would it mean to me if you got*';
  {What ,how ,who ,where ,when ,why }
Answer[ 52]:= 'Why do you ask?';
Answer[ 53]:= 'Does that question interest you?';
Answer[ 54]:= 'What answers would please you the most?';
Answer[ 55]:= 'What do you think?';
Answer[ 56]:= 'Are such questions in your mind often?';
Answer[ 57]:= 'What is that you really want to know?';
Answer[ 58]:= 'Have you asked anyone else?';
Answer[ 59]:= 'Have you asked such questions before?';
Answer[ 60]:= 'What else comes to mind when you ask that?';
  {Name}
Answer[ 61]:= 'Names don''t interest me.';
Answer[ 62]:= 'I don''t care about names - please go on.';
  {Cause}
Answer[ 63]:= 'Is that the real reason?';
Answer[ 64]:= 'Don''t any other reasons come to mind?';
Answer[ 65]:= 'Does that reason explain anything else?';
Answer[ 66]:= 'What other reasons might there be?';
  {Sorry}
Answer[ 67]:= 'Please don''t apologize!';
Answer[ 68]:= 'Apologies are not necessary.';
Answer[ 69]:= 'What feelings do you have when you apologize?';
Answer[ 70]:= 'Don''t be so defensive.';
  {Dream}
Answer[ 71]:= 'What does that dream suggest to you?';
Answer[ 72]:= 'Do you dream often?';
Answer[ 73]:= 'What persons appear in your dreams?';
Answer[ 74]:= 'Are you disturbed by your dreams?';
  {Hello }
Answer[ 75]:= 'How do you do ... please state your problem!';
  {May }
Answer[ 76]:= 'You don''t seem quite certain.';
Answer[ 77]:= 'Why the uncertain tone?';
Answer[ 78]:= 'Can''t you be more positve?';
Answer[ 79]:= 'You arn''t sure?';
Answer[ 80]:= 'Don''t you know*';
  { No }
Answer[ 81]:= 'Never mind! Please go on talking.';
Answer[ 82]:= 'Don''t say no - its always so negative.';
Answer[ 83]:= 'Why not?';
Answer[ 84]:= 'Are you sure?';
Answer[ 85]:= 'Why no?';
  {Your }
Answer[ 86]:= 'Why are you concerned about my*';
Answer[ 87]:= 'What about your own*';
  {Always }
Answer[ 88]:= 'Can''t you think of a specific example?';
Answer[ 89]:= 'When?';
Answer[ 90]:= 'What are you thinking of?';
Answer[ 91]:= 'Really, always?';
  {Think }
Answer[ 92]:= 'Do you really think so?';
Answer[ 93]:= 'But you are not sure you*';
Answer[ 94]:= 'Do you doubt you*';
  {You }
Answer[ 95]:= 'That interest me. Please tell me more.';
Answer[ 96]:= 'We were discussing you - not me!';
Answer[ 97]:= 'You are not really talking about me, are you?';
  {Yes }
Answer[ 98]:= 'And you mean that is positive?';
Answer[ 99]:= 'O.K., but tell me more about your love-life.';
Answer[100]:= 'Hm, and you think that is normal?';
Answer[101]:= 'Are you sure?';
Answer[102]:= 'I see.';
Answer[103]:= 'I understand.';
  {Friends}
Answer[104]:= 'Why do you bring up the topic of friends?';
Answer[105]:= 'Do your friends worry you?';
Answer[106]:= 'Do your friends pick on you?';
Answer[107]:= 'Are you sure you have any friends?';
Answer[108]:= 'Do you impose on your friends?';
Answer[109]:= 'Perhaps your love for friends worries you.';
  {Computer}
Answer[110]:= 'Do computers worry you?';
Answer[111]:= 'Are you talking about me in particular?';
Answer[112]:= 'Are you frightened by machines?';
Answer[113]:= 'Why do you mention computers?';
Answer[114]:= 'What do you think machines have to do with your problem?';
Answer[115]:= 'Don''t you think computers can help people?';
Answer[116]:= 'What is it about machines that worries you?';
  {Nokeyfound}
Answer[117]:= 'Say do you have any psychological problems?';
Answer[118]:= 'What does that suggest to you?';
Answer[119]:= 'I see. Have you other problems too?';
Answer[120]:= 'I''m not sure I understand you fully.';
Answer[121]:= 'Come elucidate your thoughts.';
Answer[122]:= 'Can you elaborate on that?';
Answer[123]:= 'That is quite interesting.';
  {Money}
Answer[124]:= 'Why do you have problems with money?';
Answer[125]:= 'Do you think money is everything?';
Answer[126]:= 'Are you sure that money is the problem?';
  {Eliza}
Answer[127]:= 'Do you think I''m sexy?';
Answer[128]:= 'Hey you bloody bastard, I''m not a bitch?';
Answer[129]:= 'I think we want to talk about you, not me.';
Answer[130]:= 'Why do you always bring up my name?';
  {Have you }
Answer[131]:= 'Sometimes I wish having*';
Answer[132]:= 'Yes, but I can''t show it.';
Answer[133]:= 'Yes, I have*';
Answer[134]:= 'No, I havn''t*';
  {Would you }
Answer[135]:= 'Certainly I will*';
Answer[136]:= 'Yes, of course I would. But what would you say?';
Answer[137]:= 'I ever will*';
Answer[138]:= 'I never would*';

{ Setzen der Arrays S, N, R }
Fill_s_r( 1, 98,6); {Yes }
Fill_s_r( 2,  1,2); {I have }
Fill_s_r( 3,  3,2); {I had }
Fill_s_r( 4,  5,4); {I will }
Fill_s_r( 5,  5,4); {I would }
Fill_s_r( 6,  9,3); {I was }
Fill_s_r( 7, 12,4); {I like }
Fill_s_r( 8, 25,4); {I don't }
Fill_s_r( 9, 29,3); {I feel }
Fill_s_r(10, 40,3); {I can't }
Fill_s_r(11, 43,4); {I am }
Fill_s_r(12, 43,4); {I'm }
Fill_s_r(13, 47,5); {I want }
Fill_s_r(14, 52,9); {What }
Fill_s_r(15, 54,7); {How }
Fill_s_r(16, 55,6); {Who }
Fill_s_r(17, 56,5); {Where }
Fill_s_r(18, 57,4); {When }
Fill_s_r(19, 58,3); {Why }
Fill_s_r(20,131,4); {Have you }
Fill_s_r(21,135,4); {Would you }
Fill_s_r(22, 16,3); {Can you }
Fill_s_r(23, 19,2); {Can I }
Fill_s_r(24, 21,4); {You are }
Fill_s_r(25, 21,4); {You're }
Fill_s_r(26, 32,3); {Why don't you }
Fill_s_r(27, 35,2); {Why can't I }
Fill_s_r(28, 37,3); {Are you }
Fill_s_r(29, 61,2); {Name}
Fill_s_r(30, 63,4); {Cause}
Fill_s_r(31, 67,4); {Sorry}
Fill_s_r(32, 71,4); {Dream}
Fill_s_r(33, 75,1); {Hello }
Fill_s_r(34, 92,3); {Think }
Fill_s_r(35, 76,5); {May }
Fill_s_r(36, 81,5); {No }
Fill_s_r(37, 86,2); {Your }
Fill_s_r(38, 88,4); {Always }
Fill_s_r(39, 75,1); {Hi }
Fill_s_r(40, 95,3); {You }
Fill_s_r(41,104,6); {Friend}
Fill_s_r(42,110,7); {Computer}
Fill_s_r(43,124,3); {Money}
Fill_s_r(44,127,4); {Eliza}
Fill_s_r(45,117,7); {Nokeyfound}

{ hier beginnt das Hauptprogramm }
Eingbalt:='';
Writeln('Hi, I''m Eliza tell me your problem');
Repeat  {Endlosschleife}
 Repeat {bis eine neue Eingabe vorhanden ist}
  Write('?');
  Repeat
   Readln(Eingabe);
  Until Eingabe<>'';
  Eingabe:=' '+Eingabe+' ';
  Einggros:='';
  For V:=1 to length(Eingabe) do
   Begin
    If Eingabe[V]='''' Then
     Delete(Eingabe,V,1);   {Apostrophe aussortieren}
       {Satzzeichen in Leerzeichen umwandeln}
    If (Eingabe[V]=',') OR (Eingabe[V]=';') OR
       (Eingabe[V]='?') OR (Eingabe[V]='!') OR
       (Eingabe[V]='.') Then Eingabe[V]:=' ';
     Einggros:=Einggros+upcase(Eingabe[V]);
   End;
  If Eingabe=Eingbalt Then
   Writeln('Please don''t repeat yourself!');
  If (Einggros=' BYE ') OR
     (Einggros=' GOOD BYE ') OR
     (Einggros=' QUIT ') OR
     (Einggros=' EXIT ') Then
   Begin
    Writeln('Thank you and good bye!');
    Halt
   End;
 Until Eingabe<>Eingbalt;
 { Suchen des Schluesselwortes }
 V:=0;
 Found:=False;
 While Not((V>=Anzkeyw) OR Found) Do
  Begin
   V:=V+1;  {next keyword}
   Position:=Pos(Keyword[V],Einggros);
   If Position>0 Then Found:=True;
  End;
 If Found Then    {konjugieren}
  Begin
   T:=0;
   Found:=False;
   Antwort:=Eingabe;
   Delete(Antwort,1,Position+Length(Keyword[V])-2);
   {Der Teil der Eingabe, der links vom Stichwort steht,}
   {wird abgetrennt. Diese Operation wird nur gebraucht,}
   {wenn in der Antwort von Eliza (s.u.) ein * vorkommt.}
   While (T<Anzpers) AND Not Found Do
   {Sind Personal- oder Possesivpronomen in der         }
   {bisherigen Antwort enthalten?                       }
    Begin
     {Austauschen der Person (I gegen You und umgekehrt)}
     T:=T+1;
     Position:=Pos(Person[T],Antwort);
     If Position>0 Then
      Begin
       Found:=True;
       Delete(Antwort,Position,Length(Person[T]));
       If Odd(T) Then
        Begin
         T1:=T+1;
         T :=T1;
        End
       Else
        T1:=T-1;
       Insert(Person[T1],Antwort,Position);
       {die passenden stehen nebeneinander}
       {vor dem gefundenen oder dahinter  }
      End; {If}
   End;    {While}
 End       {If}
 Else
   V:=Anzkeyw; {Nokeyfound}
 {Antwortsatz finden}
 Antw_nr:=R[V];
 {zunaechst wird die Nummer der Antwort gesucht}
 If Antw_nr<N[V] Then
   {naechste Antwort bei gleichem Stichwort}
   R[V]:=R[V]+1
  Else
   {wieder von vorne anfangen}
   R[V]:=S[V];
 {und hier der eigentliche Antwortsatz}
 Satz:=Answer[Antw_nr];
 {bei * nimmt man auf die Eingabe Bezug}
 Position:=Pos('*',Satz);
 If Position>0 Then
  Begin
   {Loeschen des *}
   Delete(Satz,Position,1);
   {stattdessen wird die alte Benutzereingabe}
   {modifiziert eingesetzt                   }
   Insert(Antwort,Satz,Position);
  End;
 Eingbalt:=Eingabe;
 Antwort :=Satz;
 {Ausgabe der Antwort}
 Writeln(Antwort);
Until False;
End.

